#!/bin/bash

VERSION=2
PRODUCT_SERIAL="$(sudo cat /sys/devices/virtual/dmi/id/product_serial)"
RELEASE_CFG=config.xcfg
CURRENT_CFG=dump.cfg
MXT_APP=/usr/bin/mxt-app
CONFIG_PATH=/opt/maXTouch


if lsusb -d 03eb:212c | grep -c Atmel > /dev/null 2>&1 ; then
	if [ -f $CONFIG_PATH/$PRODUCT_SERIAL ] ; then
		if [ "$(cat "$CONFIG_PATH/$PRODUCT_SERIAL")" = "$VERSION" ] ; then
			echo "Touch Configuration File On System Is Same Version As Update"
			echo "No Update Needed!"
			exit
		fi
	fi
	echo "Getting Touch Configuration From System"
	$MXT_APP --save $CONFIG_PATH/$CURRENT_CFG

	#Check if dump.cfg from system is the same as load.cfg firmware file, ignore lines lines 6 and 7.
	#These lines are output diagnostic information fields and correspond to T44 and T5 in the Object-Base Server menu.
	if diff <(sed '6,7d' $CONFIG_PATH/$CURRENT_CFG) <(sed '6,7d' $CONFIG_PATH/$RELEASE_CFG) > /dev/null 2>&1 ; then
		echo "Touch Configuration File On System Matches Update"
	else
		echo "Touch Configuration File On System Differs From Update"
		echo "Loading New Configuration"
		if $MXT_APP --load $CONFIG_PATH/$RELEASE_CFG ; then
			echo "Updated Version To $VERSION"
		else
			echo "Touch screen firmware did not load"
			exit
		fi
	fi
	echo "$VERSION" > $CONFIG_PATH/$PRODUCT_SERIAL
	echo "Update Complete"
else
	echo "This does not contain a Atmel touch controller"
fi
